namespace Gen7 {
    [Ability effect=DoubleSpeedInWeather]
    class DoubleSpeedInWeather : PkmnScript {
        string _weather;

        void OnInitialize(const BattleLibrary@ library, const narray<EffectParameter@>@ parameters) override {
            _weather = parameters[0].AsString();
        }

        void ChangeSpeed(BaseTurnChoice@ choice, uint &inout speed) override {
            auto weather = choice.User.Battle.GetWeatherName();
            if (weather == _weather) {
                speed *= 2;
            }
        };
    }
}