namespace Gen7 {
    [Ability effect=PowerUpType]
    class PowerUpTypeAbility : PkmnScript {
        uint8 _typeId;

        void OnInitialize(const BattleLibrary@ library, const narray<EffectParameter@>@ parameters){
            _typeId = library.StaticLibrary.TypeLibrary.GetTypeId(parameters[0].AsString());
        }

        void ModifyOffensiveStatValue(ExecutingMove@ move, Pokemon@ target, uint8, float &inout value) override {
            if (move.Move.MoveData.Type == _typeId){
                value *= 1.5f;
            }
        }
    }
}